//======================================================================
// Header for conversion library that uses the Imaging component
// of Windows CE 5 and later.
//

// Call to initialize the library
HRESULT InitDisplayFrame (LPCWSTR pszExt);

// Call to convert MJPEG frame and write to a Device Context
HRESULT DisplayFrame (PBYTE pData, DWORD dwPreBuff, DWORD dwSize, HDC hdc, RECT *pRect);

HRESULT DisplayBitmap (IBitmapImage *pBitmapImage, HDC hdc, RECT *pRect);

typedef struct {
	int nHeight;
	int nWidth;
	int PixelFormat;
} BMPFMT, *PBMPFMT;

// Convert an MJPEG frame to an IBitmapImage object.
HRESULT GetBitMapImage (PBYTE pData, DWORD dwPreBuff, DWORD dwSize, 
						IBitmapImage **ppBitmapImage, PBMPFMT pInfo);

BOOL IsMotionDetected (IBitmapImage* pBitmapImage, IBitmapImage* pBitmapImageOld, PBMPFMT pInfo,
					   DWORD dwSenstivity);

// Call to free the library
HRESULT ReleaseDisplayFrame ();
